<?php

class Maintenance extends Controller
{
	
	public function Maintenance()
	{
		parent::Controller();
		
		if ($this->session->userdata("userlevel") < 5)
		{
			exit;
		}
		
	}
	
	public function index()
	{
		$message = 'The following functions exist:<br /><br />' .
					anchor("maintenance/dash2underscore","Convert dashes to underscores in material names.") .
					'<br />' .
					anchor("maintenance/garbagecollect","Find and delete unused preview images.");
					
				$this->load->view("user/message2user",array("title"=>"Maintenance functions.","message"=>$message));
	}
	
	public function dash2underscore()
	{
		//load all material libraries
		$this->load->library("igm_parser");
		
		$this->load->model("material_data");
		
		$message = "Libraries loaded. Scanning DB...";
		
		$this->db->select("*")
				 ->from('material')
				 ->orderby('matname', 'asc');
		$query = $this->db->get();
		foreach($query->result() as $row)
		{
			$theMaterial = unserialize($row->data);
			$theMaterial->setName( str_replace("-","_", $theMaterial->getName()) );
			
			$renamedMaterial = $theMaterial->fold();
			
			$this->material_data->modifyMaterialData($row->ID, $renamedMaterial);
		}
		$message .= "... done.";
		
		$q = 'UPDATE material SET matname = REPLACE(matname, "-", "_") WHERE matname LIKE "%-%"';
		$this->db->query($q);
		
		$this->load->view("user/message2user",array("title"=>"Convert Dashes2Underscores","message"=>$message));
	}
	
	public function garbagecollect()
	{
		
		$message = "Scanning MATERIALS database and filesystem....<br />";
		
		$this->db->select("*")
				 ->from('material')
				 ->orderby('matname', 'asc');
				 
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			$TF = array();
			
			foreach($query->result() as $row)
			{
				$TF[] = basename($row->thumbnailpath);
			}
			
			$foundFiles = $this->scanDirectories("./images/materials/");
			
			foreach ($foundFiles as $thumb)
			{
				$basethumb = basename($thumb);
				if ( (stristr($basethumb,"_thumb")) && (!in_array($basethumb,$TF)) )
				{
					$prev = str_replace("_thumb", "", $thumb);
					if (file_exists($thumb))
					{
						unlink($thumb);
						$message .= $thumb ." : deleted<br />";
					}
					if (file_exists($prev))
					{
						unlink($prev);
						$message .= $prev ." : deleted<br />";					
					}					
				}
			}
			$message .= "...done.<br />";
		}
		else
		{
			$message .= "...Nothing to do.";
		}
		
		/* ---------------------------------------- */
		
		$message .= "Scanning TEXTURES database and filesystem....<br />";
		
		$this->db->select("*")
				 ->from('texture')
				 ->orderby('texname', 'asc');
				 
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			
			$TF = array();
			
			foreach($query->result() as $row)
			{
				$TF[] = basename($row->thumbnailpath);
			}
			
			$foundFiles = $this->scanDirectories("./images/textures/");
			
			foreach ($foundFiles as $thumb)
			{
				$basethumb = basename($thumb);
				if ( (stristr($basethumb,"_thumb")) && (!in_array($basethumb,$TF)) )
				{
					$prev = str_replace("_thumb", "", $thumb);
					if (file_exists($thumb))
					{
						unlink($thumb);
						$message .= $thumb ." : deleted<br />";
					}
					if (file_exists($prev))
					{
						unlink($prev);
						$message .= $prev ." : deleted<br />";					
					}					
				}
			}
			$message .= "...done.<br />";
		}
		else
		{
			$message .= "...Nothing to do.";
		}
		
		$this->load->view("user/message2user",array("title"=>"Garbage Collection","message"=>$message));
	}
	
	private function scanDirectories($rootDir, $allData=array())
	{
	    // set filenames invisible if you want
	    $invisibleFileNames = array(".", "..", ".htaccess", ".htpasswd");
	    // run through content of root directory
	    $dirContent = scandir($rootDir);
	    foreach($dirContent as $key => $content) {
	        // filter all files not accessible
	        $path = $rootDir.'/'.$content;
	        if(!in_array($content, $invisibleFileNames)) {
	            // if content is file & readable, add to array
	            if(is_file($path) && is_readable($path)) {
	                // save file name with path
	                $allData[] = $path;
	            // if content is a directory and readable, add path and name
	            }elseif(is_dir($path) && is_readable($path)) {
	                // recursive callback to open new directory
	                $allData = $this->scanDirectories($path, $allData);
	            }
	        }
	    }
	    return $allData;
	}
}