<?php

class Materials extends Controller
{
	
	var $Categories;		//Holds all valid categories
	
	var $myXML;				//Material XML handler

	var $paths = array();	//paths that have been found
	
	function Materials()
	{
		parent::Controller();
		//$this->output->enable_profiler(TRUE);
		
		$this->load->library("clean");
		ob_start(array($this->clean,"process"));
		
		/* include everything :S */
		include_once APPPATH . "libraries/Texture.php";
		include_once APPPATH . "libraries/Spectrum.php";
		include_once APPPATH . "libraries/Medium.php";
		include_once APPPATH . "libraries/Blend_material.php";
		include_once APPPATH . "libraries/Diffuse_material.php";
		include_once APPPATH . "libraries/Glossy_transparent_material.php";
		include_once APPPATH . "libraries/Null_material.php";
		include_once APPPATH . "libraries/Phong_material.php";
		include_once APPPATH . "libraries/Specular_material.php";
		include_once APPPATH . "libraries/Xml_handler.php";
		
		$this->myXML = new Xml_handler();
			
		$this->load->model("material_data");
		$this->load->model("texture_data");
		$this->load->model("category_data");
		
		$this->Categories = $this->category_data->getCategories("mat");
		
		if ($this->session->userdata("userlevel") > 4)
		{
			$this->load->scaffolding("material");
		}

	}

	
	public function index()
	{
		$catCounts = array();
		foreach($this->Categories as $cID=>$cName)
		{
			$catCounts[$cID] = $this->material_data->getNumberOfMaterialsInCategory($cID);
		}
		$this->load->view("materials/index", array("categories"=>$this->Categories,
												   "catCounts"=>$catCounts));
	}
	
	public function edit($materialName = "")
	{
		if (!$this->session->userdata("loggedin"))
		{
			echo "You must be logged in to edit materials.";
			exit;
		}
		
		$materialID = $this->material_data->getIdFromName($materialName);
		if (!$this->material_data->nameExists($materialName))
		{
			echo "Specified material doesn't exist: " . $materialName;
			exit;
		}
		
		$materialData = $this->material_data->retrieveMaterial($materialID);
		if ($materialData['owner'] != $this->session->userdata("userid"))
		{
			echo "You can only edit your own materials.";
			exit;
		}
		
		$theMaterial = unserialize($materialData['data']);
		$theView = "edit/" . $theMaterial->getType();
		
		if ($this->input->post("DN") != false)
		{
			$testMat = $this->material_data->retrieveMaterial($this->input->post("materialID"));
			/* default validation rules are now in libraries/MY_Validation.php */
			if ($testMat['matname'] == $this->input->post("DN"))
			{
				//cancel name exists rule
				$myRules['DN'] = "required|trim|min_length[2]|max_length[128]|alpha_dash_space|xss_clean";
				$this->validation->set_rules($myRules);
			}
		}
		
		if($this->validation->run() == FALSE)
		{
			$categories = $this->category_data->getCategories("mat");
			$this->material_data->TABLE_NAME = "medium";
			$media = $this->material_data->getMedia(); 
			$this->material_data->TABLE_NAME = "material";
			$this->load->view($theView, array("materialData"=>$materialData, "theMaterial"=>$theMaterial, "categories"=>$categories, "media"=>$media));
		}
		else
		{
			/* material edit validation success */
			//go ahread and modify the material's settings.
			$newMaterial = $theMaterial;
			$newMaterial->setName($this->input->post("DN"));
			
			$this->load->library("material_helpers");
			
			// upload new thumb?
			//how? oh ok, i'll add another UI control ;)
			if ($this->input->post("changeThumb")=="on")
			{
				$thumbnailFile = $this->material_helpers->manageUpload($newMaterial->getType());
			}
			else
			{
				$thumbnailFile = $materialData['thumbnailpath'];
			}
			
			switch ($newMaterial->getType())
			{
				case "diffuse":
				{
					$newMaterial->setTransmitter( ($this->input->post('DT_enabled') == "on") );
				}
				break;
				
				case "glossy_transparent":
				{
					$theMedium = $this->material_data->retrieveMaterialDataById($this->input->post("Medium"));
					$newMaterial->Internal_medium = unserialize($theMedium);
					$newMaterial->setExponent( $this->input->post("Exponent") );
				}
				break;
				
				case "specular":
				{
					$theMedium = $this->material_data->retrieveMaterialDataById($this->input->post("Medium"));
					$newMaterial->Internal_medium = unserialize($theMedium);
					$newMaterial->setTransparent( ($this->input->post("ST_enabled")=="on") );
				}
				break;
				
				case "phong":
				{
					$ior = $this->input->post("IOR");
					if ($this->input->post("NK_enabled") == "on")
					{
						$newMaterial->setNkData($this->input->post("NK_data"));
						$ior = 1;
					}
					$newMaterial->setPhongData($ior,$this->input->post("Exponent"));
				}
				break;
				
				case "blend":
				{
					$newMaterial->setBlendFactor($this->input->post("blendFactor"));
					$this->material_helpers->setupBlendMap($newMaterial);
					$myNull = new Null_material();
					$myNull->setName("null_material");
					if ($this->input->post("matA_null")=="on")
					{
						$newMaterial->materialA = $myNull;
					}
					else
					{
						$matA = $this->material_data->retrieveMaterialDataByName($this->input->post("matA"));
						$newMaterial->materialA = unserialize($matA);
					}
					if ($this->input->post("matB_null")=="on")
					{
						$newMaterial->materialB = $myNull;
					}
					else
					{
						$matB = $this->material_data->retrieveMaterialDataByName($this->input->post("matB"));
						$newMaterial->materialB = unserialize($matB);
					}
				}
				break;
			}
			
			//conditional on each of these
			if (isset($newMaterial->Albedo_spectrum))
				$this->material_helpers->setupSpectrum($newMaterial->Albedo_spectrum, "ASTabs");
			
			/* Houston, we have a Medium */
			if ($this->input->post("MTTabs_activeTab") != false)
			{
				$this->material_data->TABLE_NAME = "medium";
				$newMaterial->setPrecedence($this->input->post("Precedence"));
				
				switch ($this->input->post("MTTabs_activeTab"))
				{
					case MEDIUM_BASIC:						
						$ior = $this->input->post("MTTabs_IOR");
						$cauchy_b = $this->input->post("MTTabs_Cauchy_b");
						$sss = ($this->input->post("SSS_enabled") == "on");
						if ($this->input->post("PFTabs_activeTab") > 0) $PF = $this->input->post("PFTabs_activeTab"); else $PF = MEDIUM_PHASE_NOTSET;
						
						$newMaterial->setBasic($ior, $cauchy_b, $sss, $PF);
						
						$this->material_helpers->setupSpectrum($newMaterial->BASIC_absorption_coefficient_spectrum, "ACSTabs");

						if ($sss)
						{
							$this->material_helpers->setupSpectrum($newMaterial->BASIC_sss_coefficient_spectrum, "SCSTabs");
							if ($PF == MEDIUM_PHASE_HENYEY)
								$this->material_helpers->setupSpectrum($newMaterial->BASIC_sss_phase_g_spectrum, "GSTabs");
							else
								$newMaterial->BASIC_sss_phase_g_spectrum = false;
						}
					break;
					
					case MEDIUM_DERMIS:
						$newMaterial->BASIC_absorption_coefficient_spectrum_spectrum = false;
						$newMaterial->BASIC_sss_phase_g_spectrum = false;
						$newMaterial->BASIC_sss_phase_g_spectrum = false;
						
						$newMaterial->setDermis($this->input->post("MTTabs_HG_Frac"));
					break;
					
					case MEDIUM_EPIDERMIS:
						$newMaterial->BASIC_absorption_coefficient_spectrum_spectrum = false;
						$newMaterial->BASIC_sss_phase_g_spectrum = false;
						$newMaterial->BASIC_sss_phase_g_spectrum = false;
						
						$newMaterial->setEpidermis($this->input->post("MTTabs_M_Frac"), $this->input->post("MTTabs_MTB"));
					break;
				}
			}				
				
			//these don't need conditionals ! :)
			$this->material_helpers->setupAlbedoTexture($newMaterial);
			$this->material_helpers->setupExponentMap($newMaterial);
			
			//This is only conditional here because I chose BM_ for both
			//bump_map and blend_map; oh well.
			if ($newMaterial->getType()=="blend")
				$this->material_helpers->setupBlendMap($newMaterial);
			else
				$this->material_helpers->setupBumpMap($newMaterial);
			
			if (!$theMaterial = $newMaterial->generateXML())
				$data['message'] = $newMaterial->error_string;
			else
			{
				$name = $this->input->post("DN");
				$description = $this->input->post("Description");
				$category = $this->input->post("Category");
				$thumb = $thumbnailFile;
				$materialData = $newMaterial->fold();
				
				if ($this->material_data->modifyMaterial($this->input->post("materialID"), $name, $description, $category, $thumb, $materialData))
				{
					//Success!
					echo "<p>Material updated successfully";
					$this->details($this->input->post("DN"));
				}
				else
				{
					echo "<p>Database error.</p>";
				}
			}
			$this->material_data->TABLE_NAME = "material";
		}
	}
	
	public function delete($materialName, $confirm = 0)
	{
		$matID = $this->material_data->getIdFromName($materialName);
		$theMaterial = $this->material_data->retrieveMaterial($matID);
		if ($theMaterial['type'] == "medium")
		{
			$this->material_data->TABLE_NAME = "medium";
		}
		if ($theMaterial['owner'] != $this->session->userdata("userid"))
		{
			echo "You cannot delete materials that aren't yours.";
			exit;
		}
		
		if ($confirm == 0)
		{
			echo '<p>This action is irreversible, are you sure?</p>';
			echo '<p>' . anchor("materials/delete/".$materialName."/1/","Yes") . ' <a href="#" onClick="tb_remove();">No</a></p>';
		}
		elseif ($confirm == 1)
		{
			if ($this->material_data->deleteMaterial($matID))
			{
				//also think about removing the files here - or write a GarbageCollect script.
				//success
				$this->load->view("user/message2user", array("title"=>"Success", "message"=>"Material successfully deleted."));
			}
			else
			{
				//fail
				$this->load->view("user/message2user", array("title"=>"Error", "message"=>"The material could not be deleted."));
			}
		}
		$this->material_data->TABLE_NAME = "material";
	}
	
	/* material detail http://site/materials/details/7264 */
	public function details($materialName)
	{
		if ($materialID = $this->material_data->getIdFromName($materialName))
		{
			$matArray = $this->material_data->retrieveMaterial($materialID);
			$theMaterial = unserialize($matArray['data']);
			
			$theMaterialXML = $theMaterial->generateXML();
			$this->myXML->setXML($theMaterialXML);
			$matArray['XML'] = htmlentities($this->myXML->getTidyXML());
			
			$this->load->view("materials/materialView", $matArray);
		}
		else
		{
			echo "Material name $materialName not found.";
		}
	}
	
	/* material category http://site/materials/category/5 */
	public function category($catID)
	{
		$catname = $this->category_data->getCategoryNameFromId("mat", $catID);
		$theMats = $this->material_data->getMaterialsInCategory($catID);
		//echo var_export($theMats,true); exit;
		$this->load->view("materials/categoryView", array("theMats"=>$theMats,
														  "catName"=>$catname,
														  "catID"=>$catID,
														  "categories"=>$this->Categories));
	}
	
	public function random()
	{
		$theMats = $this->material_data->randomMaterial(6);
		//echo var_export($theMats,true); exit;
		$this->load->view("materials/categoryView", array("theMats"=>$theMats,
												  "catName"=>"Random Materials",
												  "catID"=>-1,
												  "categories"=>$this->Categories));
	}
	
	public function popular()
	{
		$theMats = $this->material_data->mostDownloaded(6);
		//echo var_export($theMats,true); exit;
		$this->load->view("materials/categoryView", array("theMats"=>$theMats,
												  "catName"=>"Most Downloaded",
												  "catID"=>-1,
												  "categories"=>$this->Categories));
	}
	
	/* material by user http://site/materials/user/dougal2 */
	public function user($owner = "", $category = NULL)
	{
		
		$theMats = $this->material_data->getMaterialsByOwner($owner, $category);
		//echo var_export($theMats,true); exit;
		$this->load->view("materials/categoryView", array("theMats"=>$theMats,
														  "catName"=>"<i>".$owner."</i>",
														  "catID"=>-1,
														  "categories"=>$this->Categories));
	}
	
	public function search($string = "", $mode = "plain")
	{
		if ($string == "")
		{
			$this->load->view("materials/search");
		}
		else
		{
			//perform AJAX magic
			/* non-XHTML output, turn off TIDY ! */
			$this->clean->USE_TIDY = false;
			
			$matMatches = $this->material_data->findMaterials($string);
			$strMatches = implode("\n",$matMatches);
			switch ($mode)
			{
				case "plain":
					echo $strMatches;
				break;
				
				case "html":
					if (count($matMatches) == 0)
						echo "<i>No results</i>";
					else
					{
						foreach($matMatches as $match)
						{
							echo '<a title="Search Result" class="thickbox" href="'.site_url().'materials/details/'.$match.'">'.$match.'</a><br />';
						}					
					}
				break;
			}
		}
	}
	
	public function export($materialID,$format = "pigm")
	{
		$this->clean->USE_TIDY = false; //binary output
		$this->clean->COMPRESS = false;
		
		$matArray = $this->material_data->retrieveMaterial($materialID);
		$theMaterial = unserialize($matArray['data']);
		
		//Get the material's name
		$materialName = $theMaterial->getName();
		
		//set the file name
		$fileName = $materialName . '.igm';
		
		//Tidy and set the XML
		$theMaterialXML = $theMaterial->generateXML();
		$this->myXML->setXML($theMaterialXML);
		$tidyXML = $this->myXML->getTidyXML();
		
		switch($format)
		{
			case "pigm":
			case "zip":
				$this->load->library('zip');
				
				$fileData = $tidyXML;
				
				//Add info to zip
				$siteInfo  = "Downloaded from Indigo materials database ~ " . site_url() ."\r\n";
				$siteInfo .= "\r\nMaterial by " . $matArray['username'] . " ~ " . unix_to_human($matArray['dateadded'], false, 'eu') . "\r\n";
				$siteInfo .= "\r\nAuthor's description:\r\n" . $matArray['description'];
				$this->zip->add_data("info.txt", $siteInfo);
				
				//Add .igm to zip
				$this->zip->add_data($fileName, $fileData);
				
				//Find and add textures
				$sXML = new Simple_XML_Parser();
				$sXML->parse($tidyXML);
				$this->paths = array();	//reset paths
				array_walk_recursive($sXML->data, array($this, 'findPathInXML'));
				foreach($this->paths as $texFile)
				{
					$this->zip->read_file($texFile, true);
				}
				
				//Send the zip with proper extension to the user
				$this->zip->download($materialName.'.'.$format);
			break;
			
			case "igm":
				$this->load->helper('download');
				force_download($fileName, $tidyXML);
			break;
		}
		
		$this->material_data->incrementDownloads($materialID);
	}

	private function findPathInXML($data,$key)
	{
		if (file_exists($data))
		{
			$this->paths[] = $data;
		}
	}
	
	
	
	/* more validation bollocks - keep synced with controllers/create.php */
	function name_check($name)
	{
		if ($this->material_data->nameExists($name))
		{
			$this->validation->set_message('name_check', 'That material name exists already. Please choose another.');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	function material_exists($name)
	{
		if (!$this->material_data->nameExists($name))
		{
			$this->validation->set_message('material_exists', 'The material %s doesn\'t exist. Please try another.');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	function texture_exists($name)
	{
		if (!$this->texture_data->nameExists($name))
		{
			$this->validation->set_message('texture_exists', 'The %s doesn\'t exist. Please try another.');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	function category_check($val)
	{
		if ($val == -1)
		{
			$this->validation->set_message('category_check', 'Please choose a category.');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	function medium_check($val)
	{
		if ($val < 0)
		{
			$this->validation->set_message('medium_check', 'Please choose an internal medium.');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	function check2nulls($val)
	{
		if (($this->input->post("matA_null")=="on") && ($this->input->post("matB_null")=="on")) 
		{
			$this->validation->set_message('check2nulls', 'You cannot set both Material A and Material B to Null.');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
}
?>