<?php

class Diffuse_test extends Controller
{
	private $myDiffuse;
	private $myXML;
	
	function Diffuse_test()
	{
		parent::Controller();
		
		include_once APPPATH . "libraries/Diffuse_material.php";
		include_once APPPATH . "libraries/Xml_handler.php";
	}
	
	function index()
	{
		$this->myDiffuse = new Diffuse_material();
		$this->myDiffuse->setName("TestDiffuse");
		$this->myDiffuse->Albedo_spectrum->setRGB(550, 50, 1, 2.2);
		
		$this->myDiffuse->setTransmitter(true);
		
		$this->myDiffuse->initAlbedoTexture();
		$this->myDiffuse->Albedo_texture->setPath("../textures/test.png");
		$this->myDiffuse->Albedo_texture->setExponent(2.2);
		$this->myDiffuse->Albedo_texture->setABC(1,2,0.3);
		
		$this->myDiffuse->initBumpMap();
		$this->myDiffuse->Bump_map->setPath("../bumpmaps/test.png");
		$this->myDiffuse->Bump_map->setExponent(1.0);
		$this->myDiffuse->Bump_map->setABC(0,0.03,0);
		
		if (!$theMaterial = $this->myDiffuse->generateXML())
			echo $this->myDiffuse->error_string;
		
		$this->myXML = new Xml_handler();
		$this->myXML->setXML($theMaterial);
		echo "<pre>" . htmlentities($this->myXML->getTidyXML()) . "</pre>";
	}
}
?>