<?php

class User extends Controller
{
	
	var $c_userdata = array();
	/*
	 - db_username
	 - db_fullname
	 - db_email
	 - db_password
	*/
	
	function User()
	{
		parent::Controller();
		//$this->output->enable_profiler(TRUE);
		
		$this->load->library("clean");
        ob_start(array($this->clean,"process"));
		
		$this->load->model("user_data");
		
		$this->c_userdata = $this->user_data->getDBUserData($this->session->userdata("userid"));
		
		$this->validation->remove_rule("DN");
		$this->validation->remove_rule("Category");
		
		if ($this->session->userdata("userlevel") > 4)
		{
			$this->load->scaffolding("user");
		}
	}
	
	function index()
	{
		if ($this->session->userdata("loggedin") == true)
		{
			$this->load->view("user/index");
		}
		else
		{
			$this->load->view("user/message2user", array("title"=>"You are not logged in!", "message"=>"Please use the login or register functions on the right."));
		}
	}
	
	function login()
	{
		$user = $this->input->post("username");
		$pass = $this->input->post("password");
		if ((!$user) || (!$pass))
		{
			$this->load->view("user/message2user", array("title"=>"Login Error", "message"=>"Please enter both a username and password."));
		}
		else
		{
			$loginResult = $this->user_data->doLogin($user, $pass);
			switch ($loginResult)
			{
				/* negative numbers are errors */
				case -1:
				$error_msg = "Login failed: Incorrect password.";
				$this->load->view("user/message2user", array("title"=>"Login Error", "message"=>$error_msg));
				break;
				
				case -2:
				$error_msg = "Login failed: Unknown username.";
				$this->load->view("user/message2user", array("title"=>"Login Error", "message"=>$error_msg));
				break;
				
				/* default case is where doLogin returns the user's ID# */
				default:
				$theUserData = $this->user_data->getDBUserData($loginResult);
				$nuData = array("loggedin" => true,
								"username" => $user,
								"userid" => $loginResult,
								"userlevel" => $theUserData['db_userlevel']);
								
				$this->session->set_userdata($nuData);
				
				$this->load->view("user/index");
				break;
			}
		}
	}
	
	function logout()
	{
		$this->session->sess_destroy();
		$this->load->helper('url');
		header("Location: ". site_url());
	}
	
	function register()
	{
		//echo "Temporarily disabled.";
		//exit;
		
		$rules['username'] = "required|strip_tags|alpha_dash|trim|min_length[5]|max_length[24]|callback_username_check1|callback_username_check2|xss_clean";
		$rules['fullname'] = "trim|strip_tags|max_length[128]|xss_clean";
		$rules['passw1'] = "required|alpha_dash|trim|min_length[5]|max_length[24]|matches[passw2]|xss_clean";
		$rules['passw2'] = "required|alpha_dash|trim|min_length[5]|max_length[24]|xss_clean";
		$rules['email'] = "required|trim|valid_email|xss_clean";
		$this->validation->set_rules($rules);
		
		$fields['username'] = 'Username';
		$fields['fullname'] = 'Full Name';
		$fields['passw1'] = 'Password';
		$fields['passw2'] = 'Password Confirmation';
		$fields['email'] = 'Email Address';
		$this->validation->set_fields($fields);
		
		$this->validation->set_error_delimiters('<div class="error">', '</div>');
		
		if($this->validation->run() == FALSE)
		{
			$this->load->view("user/register");
		}
		else
		{
			$u = $this->input->post("username");
			$f = $this->input->post("fullname");
			$e = $this->input->post("email");
			$p = $this->input->post("passw1");
			
			if ($this->user_data->addNewUser($u, $f, $e, $p))
			{
				$data = array("title"=>"Registration",
							  "message"=>"You have successfully registered the following username: $u.<br /><br />You may now log in.");				
			}
			else
			{
				$data = array("title"=>"Registration", "message"=>"Something went wrong with your registration. Please try again, or contact a site adminstrator.");
			}
			
			$this->load->view("user/message2user",$data);
		}
	}
	
	function edit()
	{
		if (!$this->session->userdata("loggedin"))
		{
			$data = array("title"=>"Error",
						  "message"=>"You are not logged in.");
			$this->load->view("user/message2user",$data);
		}
		else
		{
			if ($this->input->post("username") == $this->session->userdata("username"))
			{
				//user hasn't changed name, don't chekc if it;s already regsiteres
				$rules['username'] = "required|strip_tags|alpha_dash|trim|min_length[5]|max_length[24]|callback_username_check1|xss_clean";
			}
			else
			{
				//user is changing name, don't let them use an existing one.
				$rules['username'] = "required|strip_tags|alpha_dash|trim|min_length[5]|max_length[24]|callback_username_check1|callback_username_check2|xss_clean";
			}
			
			$rules['fullname'] = "trim|strip_tags|max_length[128]|xss_clean";
			$rules['passw1'] = "alpha_dash|trim|min_length[5]|max_length[24]|matches[passw2]|xss_clean";
			$rules['passw2'] = "alpha_dash|trim|min_length[5]|max_length[24]|xss_clean";
			$rules['email'] = "required|trim|valid_email|xss_clean";
			$this->validation->set_rules($rules);
			
			$fields['username'] = 'Username';
			$fields['fullname'] = 'Full Name';
			$fields['passw1'] = 'Password';
			$fields['passw2'] = 'Password Confirmation';
			$fields['email'] = 'Email Address';
			$this->validation->set_fields($fields);
			
			$this->validation->set_error_delimiters('<div class="error">', '</div>');
			
			if($this->validation->run() == FALSE)
			{
				$existingDetails = $this->c_userdata;

				$this->load->view("user/edit",$existingDetails);
			}
			else
			{
				$u = $this->input->post("username");
				$f = $this->input->post("fullname");
				$e = $this->input->post("email");
				$p = $this->input->post("passw1");
				
				if (strlen($p)<1) $p = $this->c_userdata['db_password'];
				
				if ($this->user_data->editUserDetails($u, $f, $e, $p, $this->session->userdata("userid")))
				{
					$nuData = array("username" => $u
									);
								
					$this->session->set_userdata($nuData);
					$data = array("title"=>"User Details",
								  "message"=>"You have successfully updated your details.");				
				}
				else
				{
					$data = array("title"=>"User Details", "message"=>"Something went wrong updating your details. Please try again, or contact a site adminstrator.");
				}
				
				$this->load->view("user/message2user",$data);
			}
		}
	}
	
	function help($helpType = false)
	{
		
		
		switch($helpType)
		{
			case false:
				$message = 'Current help options are:</p>
				<h3>Forgotten Password</h3>' .
				form_open("user/help/forgotpw") .
				'<p>We can email your password to you. Enter your username:<br />
				<input name="username" /><br />
				<input type="submit" value="Send Email"/></p></form>';
			break;
				
			case "forgotpw":
				$username = $this->input->post("username");
				if (strlen($username) < 1)
				{
					$message = "You need to enter a username.";
				}
				else
				{
					$userID = $this->user_data->getUserIdFromName($username);
					if ($userID == false)
					{
						$message = "That username was not found in the database.";
					}
					else
					{
						$userDetails = $this->user_data->getDBUserData($userID);
				
						$this->load->library("email");
						$this->email->from("forgottenpasswords@indigomaterials.uk.to", "Indigo Materials Database");
						$this->email->to($userDetails['db_email']);
						$this->email->subject("Indigo Materials Database Password");
						$this->email->message("Your details are:\n\nusername: ".$username."\npassword: ".$userDetails['db_password']);
						
						if ($this->email->send())
						{
							$message = "Your password has been emailed to you.";
						}
						else
						{
							$message = "Your password could not be emailed. Either register a new username, or contact support@indigomaterials.uk.to";
						}
					}
				}
			break;
		}
		
		$this->load->view("user/message2user",array("title"=>"User help","message"=>$message));
	}
	
	function username_check1($u)
	{
		$badUsernames = array( "admin", "moderator", "administrator", );
		if ($this->is_in_array($u, $badUsernames))
		{
			$this->validation->set_message('username_check1', 'The %s field can not be the word "'.$u.'"');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	
	function username_check2($u)
	{
		if ($this->user_data->usernameExists($u))
		{
			$this->validation->set_message('username_check2', 'The user name "'.$u.'" has already been registered.');
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	
	function is_in_array($needle, $haystack, $case_sensitive=false)
	{
    	if($case_sensitive===false)
			$needle=strtolower($needle);
	     
	    foreach($haystack as $v)
	    {
	        if(!is_array($v))
	        {
	          if(!$case_sensitive)
	            $v=strtolower($v);
	         
	          if($needle == $v)        
	            return true;
	        }
	        else
	        {
	            if($this->is_in_array($needle, $v, $case_sensitive) === true)
	              return true;
	        }
	    }
	    return false;
	}
}
?>
