<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

/**
 *
 * Process the output buffer.
 * Mainly runs through TIDY.
 * Can also fix alpha channel PNGs and gz compress
 *
 */
ini_set('zlib.output_compression_level', 9);

class Clean {
        var $USE_TIDY = true; //use the tidy library
        var $FIX_IEPNG = false; //fix alpha channels in IE
        var $COMPRESS = true;

        //this func is called externally to process the output buffer
        function process($data)
		{
        	return $this->compress($this->tidy($this->fixpngs($data)));
        }

        //HTML Tidy functions
        function tidy($data) {
                if ($this->USE_TIDY) {
                        
                         // This is the sensible PHP extension way...  
                         /*
                         $config = array (
                                'indent' => true,
                                'output-xhtml' => true,
                                'indent-spaces' => 1,
                                'doctype' => 'strict',
                                'wrap' => 999,
                                'char-encoding' => 'utf8',
		   						'input-encoding' => 'utf8'
                        );

                        return tidy_repair_string($data, $config, 'utf8');
						*/
						
						
						/*
						 	//This is the crazy DreamHost way :S
						 */
						
						$descriptorspec = array(
						  0 => array("pipe", "r"), // stdin is a pipe that the child will read from
						  1 => array("pipe", "w"), // stdout is a pipe that the child will write to
						  2 => array("pipe", "r") // stderr
						);
						
						$process = proc_open('tidy -m --tidy-mark false --indent true --output-xhtml true --indent-spaces 1 --doctype strict --wrap 999 --char-encoding utf8 --input-encoding utf8', $descriptorspec, $pipes);
						
						if (is_resource($process)) {
						
						  // $pipes now looks like this:
						  // 0 => writeable handle connected to child stdin
						  // 1 => readable handle connected to child stdout
						  // 2 => stderr pipe
						
						  // writes the bad html to the tidy process that is reading from stdin.
						  fwrite($pipes[0], $data);
						  fclose($pipes[0]);
						
						  // reads the good html from the tidy process that is writing to stdout.
						  $good_html = stream_get_contents($pipes[1]);
						  fclose($pipes[1]);
						
						  // don't care about the stderr, but you might.
						
						  // It is important that you close any pipes before calling
						  // proc_close in order to avoid a deadlock
						  $return_value = proc_close($process);
						}
						
						// now use $good_html for whatever
						return $good_html;
						

                } else {
                        return $data;
                }
        }

        //gz compress (output to browser only)
        function compress($data) {
                if ($this->COMPRESS)
                        return ob_gzhandler($data, 1);
                else
                        return $data;
        }

        //a dirty hack to fix alpha channel PNGs in IE
        function fixpngs($data) {
                //IE PNG Fix
                if ($this->FIX_IEPNG) {
                        require_once '../functions/functions.replacePngTags.php';
                        return replacePngTags($data);
                } else {
                        return $data;
                }
        }

}
?>