<?
/*
 * Extend the CI Validation class with some more functions
 * 
 * remove_rule($name)
 *  Remove a validation rule from the _rules array
 *
 * DH 12/07
 */

Class MY_Validation extends CI_Validation
{
	var $_rules = array();	//The validation rules

	function My_Validation()
	{
		parent::CI_Validation();
		
		$this->set_error_delimiters('<div class="error">', '</div>');
		$this->_setIMDBFieldNames();
		$this->_setIMDBRules();
	}
	
	function remove_rule($name)
	{
		if(isset($this->_rules[$name])) unset($this->_rules[$name]);
	}


	/* And here's the default validation rules for imdb */

	function _setIMDBFieldNames()
	{
		/* User Friendly field names */
		$this->fields['DN'] = "Name";
		$this->fields['Description'] = "Description";
		$this->fields['Category'] = "Category";
		/* For Specular/Glosy transparent */
		$this->fields['Medium'] = "Medium";
		/* For phong */
		$this->fields['IOR'] = "Index of refraction";
		$this->fields['NK_data'] = "NK Data path";
		$this->fields['Exponent'] = "Exponent value";
		/* For medium */
		$this->fields['Precedence'] = "Precedence";
		/* For blends */
		$this->fields['matA'] = "Material A";
		$this->fields['matB'] = "Material B";
		$this->fields['blendFactor'] = "Blend factor";
		/* Absorption coefficient spectrum */
		$this->fields['ACSTabs_RGB_R'] = "R value";
		$this->fields['ACSTabs_RGB_G'] = "G value";
		$this->fields['ACSTabs_RGB_B'] = "B value";
		$this->fields['ACSTabs_RGB_Gamma'] = "RGB gamma";
		$this->fields['ACSTabs_PMin'] = "Peak Min value";
		$this->fields['ACSTabs_PWidth'] = "Peak Width value";
		$this->fields['ACSTabs_PPeak'] = "Peak value";
		$this->fields['ACSTabs_PBase'] = "Base value";
		$this->fields['ACSTabs_BBTemp'] = "Blackbody temperature";
		$this->fields['ACSTabs_BBGain'] = "Blackbody gain";
		$this->fields['ACSTabs_Uniform'] = "Uniform value";
		$this->fields['ACSTabs_TAB_START'] = "Tabulated spectrum start";
		$this->fields['ACSTabs_TAB_END'] = "Tabulated spectrum end";
		$this->fields['ACSTabs_TAB_VALUES'] = "Tabulated values";
		/* Scattering coefficient spectrum */
		$this->fields['SCSTabs_RGB_R'] = "R value";
		$this->fields['SCSTabs_RGB_G'] = "G value";
		$this->fields['SCSTabs_RGB_B'] = "B value";
		$this->fields['SCSTabs_RGB_Gamma'] = "RGB gamma";
		$this->fields['SCSTabs_PMin'] = "Peak Min value";
		$this->fields['SCSTabs_PWidth'] = "Peak Width value";
		$this->fields['SCSTabs_PPeak'] = "Peak value";
		$this->fields['SCSTabs_PBase'] = "Base value";
		$this->fields['SCSTabs_BBTemp'] = "Blackbody temperature";
		$this->fields['SCSTabs_BBGain'] = "Blackbody gain";
		$this->fields['SCSTabs_Uniform'] = "Uniform value";
		$this->fields['SCSTabs_TAB_START'] = "Tabulated spectrum start";
		$this->fields['SCSTabs_TAB_END'] = "Tabulated spectrum end";
		$this->fields['SCSTabs_TAB_VALUES'] = "Tabulated values";
		/* Henyey Greenstein G spectrum */
		$this->fields['GSTabs_RGB_R'] = "R value";
		$this->fields['GSTabs_RGB_G'] = "G value";
		$this->fields['GSTabs_RGB_B'] = "B value";
		$this->fields['GSTabs_RGB_Gamma'] = "RGB gamma";
		$this->fields['GSTabs_PMin'] = "Peak Min value";
		$this->fields['GSTabs_PWidth'] = "Peak Width value";
		$this->fields['GSTabs_PPeak'] = "Peak value";
		$this->fields['GSTabs_PBase'] = "Base value";
		$this->fields['GSTabs_BBTemp'] = "Blackbody temperature";
		$this->fields['GSTabs_BBGain'] = "Blackbody gain";
		$this->fields['GSTabs_Uniform'] = "Uniform value";
		$this->fields['GSTabs_TAB_START'] = "Tabulated spectrum start";
		$this->fields['GSTabs_TAB_END'] = "Tabulated spectrum end";
		$this->fields['GSTabs_TAB_VALUES'] = "Tabulated values";
		/* Basic/Dermis/Epidermis */
		$this->fields['MTTabs_IOR'] = "Index of Refraction";
		$this->fields['MTTabs_Cauchy_b'] = "Cauchy B Coefficient";
		$this->fields['MTTabs_HG_Frac'] = "Hemoglobin Fraction";
		$this->fields['MTTabs_M_Frac'] = "Melanin Fraction";
		$this->fields['MTTabs_MTB'] = "Melanin Type Blend";
		/* Albedo Spectrum */
		$this->fields['ASTabs_RGB_R'] = "R value";
		$this->fields['ASTabs_RGB_G'] = "G value";
		$this->fields['ASTabs_RGB_B'] = "B value";
		$this->fields['ASTabs_RGB_Gamma'] = "RGB gamma";
		$this->fields['ASTabs_PMin'] = "Peak Min value";
		$this->fields['ASTabs_PWidth'] = "Peak Width value";
		$this->fields['ASTabs_PPeak'] = "Peak value";
		$this->fields['ASTabs_PBase'] = "Base value";
		$this->fields['ASTabs_BBTemp'] = "Blackbody temperature";
		$this->fields['ASTabs_BBGain'] = "Blackbody gain";
		$this->fields['ASTabs_Uniform'] = "Uniform value";
		$this->fields['ASTabs_TAB_START'] = "Tabulated spectrum start";
		$this->fields['ASTabs_TAB_END'] = "Tabulated spectrum end";
		$this->fields['ASTabs_TAB_VALUES'] = "Tabulated values";
		/* Albedo Texturing */
		$this->fields['ATTabs_UVSet'] = "Albedo texture UV set";
		$this->fields['ATTabs_Path'] = "Albedo texture";
		$this->fields['ATTabs_Exponent'] = "Albedo texture exponent";
		$this->fields['ATTabs_A'] = "Albedo texture A value";
		$this->fields['ATTabs_B'] = "Albedo texture B value";
		$this->fields['ATTabs_C'] = "Albedo texture C value";
		/* Bump Mapping */
		$this->fields['BMTabs_UVSet'] = "Bump map UV set";
		$this->fields['BMTabs_Path'] = "Bump map";
		$this->fields['BMTabs_Exponent'] = "Bump map exponent";
		$this->fields['BMTabs_A'] = "Bump map A value";
		$this->fields['BMTabs_B'] = "Bump map B value";
		$this->fields['BMTabs_C'] = "Bump map C value";
		/* Exponent Mapping */
		$this->fields['EMTabs_UVSet'] = "Exponent map UV set";
		$this->fields['EMTabs_Path'] = "Exponent map";
		$this->fields['EMTabs_Exponent'] = "Exponent map exponent";
		$this->fields['EMTabs_A'] = "Exponent map A value";
		$this->fields['EMTabs_B'] = "Exponent map B value";
		$this->fields['EMTabs_C'] = "Exponent map C value";
		
		$this->set_fields($this->fields);
	}

	function _setIMDBRules()
	{
		$CI =& get_instance();
		
		/* Field validation rules */
		$myRules['DN'] = "required|trim|min_length[2]|max_length[128]|callback_name_check|alpha_dash_space|xss_clean";
		$myRules['Description'] = "trim|strip_tags|xss_clean";
		$myRules['Category'] = "required|callback_category_check|xss_clean";
		$myRules['IOR'] =
		$myRules['Exponent'] =
		$myRules['MTTabs_IOR'] =
		$myRules['MTTabs_Cauchy_b'] =
		/* Spectrum validation is dealt with below... */
		$myRules['ATTabs_Exponent'] = 
		$myRules['ATTabs_A'] = 
		$myRules['ATTabs_B'] = 
		$myRules['ATTabs_C'] =
		$myRules['BMTabs_Exponent'] = 
		$myRules['BMTabs_A'] = 
		$myRules['BMTabs_B'] = 
		$myRules['BMTabs_C'] = 
		$myRules['EMTabs_Exponent'] = 
		$myRules['EMTabs_A'] = 
		$myRules['EMTabs_B'] = 
		$myRules['EMTabs_C'] = "trim|numeric|xss_clean";
		
		/* Albedo/Bump/Exponent map checking */
		if($CI->input->post("AT_enabled") == "on")
		{
			$myRules['ATTabs_UVSet'] = "required|trim|min_length[3]|max_length[128]|alpha_numeric|xss_clean";
			$myRules['ATTabs_Path'] = "required|trim|min_length[3]|max_length[128]|callback_texture_exists|xss_clean";
		}
		
		if($CI->input->post("BM_enabled") == "on")
		{
			$myRules['BMTabs_UVSet'] = "required|trim|min_length[3]|max_length[128]|alpha_numeric|xss_clean";
			$myRules['BMTabs_Path'] = "required|trim|min_length[3]|max_length[128]|callback_texture_exists|xss_clean";
		}
		
		if($CI->input->post("EM_enabled") == "on")
		{
			$myRules['EMTabs_UVSet'] = "required|trim|min_length[3]|max_length[128]|alpha_numeric|xss_clean";
			$myRules['EMTabs_Path'] = "required|trim|min_length[3]|max_length[128]|callback_texture_exists|xss_clean";
		}
		
		//known Spectrum types:
		//ACS = Absorption coefficient spectrum
		//SCS = Scattering		"		   "
		//GS =  Henyey Greenstein G Spectrum
		//AS = Albedo Spectrum
		$prefixes = array("ACS"=>true,
						  "SCS"=>($CI->input->post("SSS_enabled") == "on"),
						  "GS"=>($CI->input->post("PFTabs_activeTab") == "2"),
						  "AS"=>!($CI->input->post("AT_enabled") == "on"));
		
		foreach($prefixes as $prefix=>$check)
		{
			//Don't validate the SSS relates spectra unless SSS is enabled
			if ($check)
			{
				//If any spectrum tabs are active, make the fields required
				switch($CI->input->post($prefix."Tabs_activeTab"))
				{
					case "1":
					$myRules[$prefix."Tabs_RGB_R"] = 
					$myRules[$prefix."Tabs_RGB_G"] =
					$myRules[$prefix."Tabs_RGB_B"] = 
					$myRules[$prefix."Tabs_RGB_Gamma"] = "required|trim|numeric|xss_clean";
					break;
					 
					case "2":
					$myRules[$prefix."Tabs_PMin"] = 
					$myRules[$prefix."Tabs_PWidth"] = 
					$myRules[$prefix."Tabs_PPeak"] = 
					$myRules[$prefix."Tabs_PBase"] = "required|trim|numeric|xss_clean";
					break;
					
					case "3": 
					$myRules[$prefix."Tabs_BBTemp"] = 
					$myRules[$prefix."Tabs_BBGain"] = "required|trim|numeric|xss_clean";
					break;
					
					case "4":
					$myRules[$prefix."Tabs_Uniform"] = "required|trim|numeric|xss_clean";
					break;
					
					case "5":
					$myRules[$prefix."Tabs_TAB_START"] = 
					$myRules[$prefix."Tabs_TAB_END"] = "required|trim|numeric|xss_clean";
					$myRules[$prefix."Tabs_TAB_VALUES"] = "required|trim|xss_clean";
					break;
					
					default:
					$myRules[$prefix."Tabs_RGB_R"] =	//all of the following are equal; 
					$myRules[$prefix."Tabs_RGB_G"] = 	//default numeric fields
					$myRules[$prefix."Tabs_RGB_B"] = 
					$myRules[$prefix."Tabs_PMin"] = 
					$myRules[$prefix."Tabs_PWidth"] = 
					$myRules[$prefix."Tabs_PPeak"] = 
					$myRules[$prefix."Tabs_PBase"] = 
					$myRules[$prefix."Tabs_BBTemp"] = 
					$myRules[$prefix."Tabs_BBGain"] = 
					$myRules[$prefix."Tabs_Uniform"] = 
					$myRules[$prefix."Tabs_TAB_START"] = 
					$myRules[$prefix."Tabs_TAB_END"] = "trim|numeric|xss_clean";
					$myRules[$prefix."Tabs_TAB_VALUES"] = "trim|xss_clean";
					break;
				}
			}
			else
			{
				$myRules[$prefix."Tabs_RGB_R"] =	//all of the following are equal; 
				$myRules[$prefix."Tabs_RGB_G"] = 	//default numeric fields
				$myRules[$prefix."Tabs_RGB_B"] = 
				$myRules[$prefix."Tabs_PMin"] = 
				$myRules[$prefix."Tabs_PWidth"] = 
				$myRules[$prefix."Tabs_PPeak"] = 
				$myRules[$prefix."Tabs_PBase"] = 
				$myRules[$prefix."Tabs_BBTemp"] = 
				$myRules[$prefix."Tabs_BBGain"] = 
				$myRules[$prefix."Tabs_Uniform"] = 
				$myRules[$prefix."Tabs_TAB_START"] = 
				$myRules[$prefix."Tabs_TAB_END"] = "trim|numeric|xss_clean";
				$myRules[$prefix."Tabs_TAB_VALUES"] = "trim|xss_clean";
			}
		}
		
		$this->set_rules($myRules);
	}
	
	/**
	 * Alpha-numeric with underscores and dashes and spaces
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */	
	function alpha_dash_space($str)
	{
		return ( ! preg_match("/^([ a-z0-9_])+$/i", $str)) ? FALSE : TRUE;
	}
	
}
?>