<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Specular_material
{
	public $error_string;
	
	private $name;					//string
	public $Internal_medium;		//Medium()
	public $Bump_map = false;		//false|Texture();
	private $Transparent = false;	//bool
	
	public function __construct()
	{
		include_once "Medium.php";
		include_once "Texture.php";
		
		$this->Internal_medium = new Medium();
	}
	public function getType()
	{
		return "specular";
	}
	public function hasAlbedoTexture() { return false; }
	public function hasBumpMap() { return true; }
	public function hasBlendMap() { return false; }
	public function hasExponentMap() { return false; }
	
	public function fold()
	{
		return serialize($this);
	}
	public function setName($newName)
	{
		$this->name = $newName;
	}
	public function getName()
	{
		return $this->name;
	}
	public function initBumpMap()
	{
		$this->Bump_map = new Texture();
	}
	public function setTransparent($trans)
	{
		$this->Transparent = $trans;
	}
	public function isTransparent()
	{
		return $this->Transparent;
	}
	
	public function generateXML()
	{
		if($this->name == "")
		{
			$this->error_string = "Specular_material::name not set";
			return false;
		}
		else
		
		if (!$theMedium = $this->Internal_medium->generateXML())
		{
			$this->error_string = "Specular_material::" .$this->Internal_medium->error_string;
			return false;
		}
		
		$specularOutput = $theMedium;
		
		$specularOutput .= "<material>\r\n";
		$specularOutput .= "\t<name>" . $this->name . "</name>\r\n";
		$specularOutput .= "\t<specular>\r\n";
		$specularOutput .= "\t\t<internal_medium_name>" . $this->Internal_medium->getName() ."</internal_medium_name>\r\n";
		$specularOutput .= "\t\t<transparent>" . (($this->Transparent)?"true":"false") . "</transparent>\r\n";
		if ($this->Bump_map != false)
		{
			$specularOutput .= "\t\t<bump_map>\r\n";
			if (!$b_text = $this->Bump_map->generateXML())
			{
				$this->error_string = "Specular_material::Bump_map::" . $this->Bump_map->error_string;
				return false;
			}
			else
			{
				$specularOutput .= $b_text;
			}
			$specularOutput .= "\t\t</bump_map>\r\n";
		}
		$specularOutput .= "\t</specular>\r\n</material>\r\n";
		
		
		return $specularOutput;
	}
}	
	
?>