<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Texture
{
	public $error_string;

	private $uv_set = "default";		//string
	private $path;						//string - is actually db texture::texname !!
	private $pathIsActualPath = false;
	private $exponent = 1;				//double
	private $a = false;					//false|double
	private $b = false;					//false|double
	private $c = false;					//false|double

	public function setUV($newUV)
	{
		$this->uv_set = $newUV;
	}
	public function setPath($newPath)
	{
		$this->path = $newPath;
	}
	public function pathIsActualPath($isit)
	{
		$this->pathIsActualPath = $isit;
	}
	
	public function setExponent($newExp)
	{
		$this->exponent = $newExp;
	}
	public function setABC($newA, $newB, $newC)
	{
		$this->a = $newA;
		$this->b = $newB;
		$this->c = $newC;
	}
	public function getDetails()
	{
		return array($this->uv_set,
					 $this->path,
					 $this->exponent,
					 array($this->a,
					 	   $this->b,
					 	   $this->c)
					 );
	}
	
	public function generateXML()
	{
		if ($this->path == "")
		{
			$this->error_string = "Texture path not set";
			return false;
		}
		
		if (!$this->pathIsActualPath)
		{
			$CI =& get_instance();
			$CI->load->model("texture_data");
			$theTexture = $CI->texture_data->retrieveTextureFromName($this->path);		
			$texPath = $theTexture['filepath'];
		}
		else
		{
			$texPath = $this->path;
		}
		
		$textureOutput  = "\t\t<uv_set>" . $this->uv_set . "</uv_set>\r\n";
		$textureOutput .= "\t\t<path>" . $texPath . "</path>\r\n";
		$textureOutput .= "\t\t<exponent>" . $this->exponent . "</exponent>\r\n";
		if ($this->a != false) $textureOutput .= "\t\t<a>" . $this->a . "</a>\r\n";
		if ($this->b != false) $textureOutput .= "\t\t<b>" . $this->b . "</b>\r\n";
		if ($this->c != false) $textureOutput .= "\t\t<c>" . $this->c . "</c>\r\n";
		
		return $textureOutput;
	}
}

?>