<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Texture_helpers
{
	private $input;			//= $CI input
	private $CI;
	
	public function __construct()
	{
		//nothing
		$this->CI =& get_instance();
		
		$this->input = $this->CI->input;
		
		$this->CI->load->model("texture_data");
	}
	
	public function manageTextureUpload($type)
	{
		$upConfig['upload_path'] = './images/textures/' . $type . '/';
		$upConfig['allowed_types'] = 'jpg|png';
		$upConfig['max_size']	= '7168';
		$upConfig['max_width']  = '6000';
		$upConfig['max_height']  = '6000';
		$upConfig['encrypt_name'] = true;
		$upConfig['remove_spaces'] = true;
		
		$this->CI->load->library('upload', $upConfig);
	
		if ( ! $this->CI->upload->do_upload("texture"))
		{	
			$this->CI->load->view("user/message2user", array("title"=>"Error","message"=>$this->CI->upload->display_errors('<p class="error">', '</p>'). '<p>Please press "Back" and try again.</p>'));
			exit;
		}	
		else
		{
			$rawThumb =  $this->CI->upload->data();
			/*
			 * Array
			(
			    [file_name]    => mypic.jpg
			    [file_type]    => image/jpeg
			    [file_path]    => /path/to/your/upload/
			    [full_path]    => /path/to/your/upload/jpg.jpg
			    [raw_name]     => mypic
			    [orig_name]    => mypic.jpg
			    [file_ext]     => .jpg
			    [file_size]    => 22.2
			    [is_image]     => 1
			    [image_width]  => 800
			    [image_height] => 600
			    [image_type]   => jpeg
			    [image_size_str] => width="800" height="200"
			)
			*/
			
			if ($thumbPath = $this->createThumbnail($rawThumb['full_path']))
			{
				return $thumbPath;
			}
			else
			{
				$this->CI->load->view("user/message2user", array("title"=>"Error","message"=>'Thumbnail could not be created.'));
				unlink($rawThumb['full_path']);
				exit;
			}
			
		}
	}
	public function createThumbnail($fullPath)
	{
		$imConfig['image_library'] = 'ImageMagick';//'GD2';
		$imConfig['library_path'] = '/usr/bin';
		$imConfig['source_image'] = $fullPath; 
		$imConfig['create_thumb'] = TRUE;
		$imConfig['maintain_ratio'] = TRUE;
		$imConfig['width'] = 150;
		$imConfig['height'] = 150;
		$imConfig['quality'] = "95%";
		
		$this->CI->load->library('image_lib', $imConfig);
		
		if ($this->CI->image_lib->resize())
		{
			$path_parts = pathinfo($fullPath);
			//"images/textures/" . $type
			
			$path_parts['dirname'] = str_replace("/home/.maestro/indigomaterials/indigomaterials.uk.to/","",$path_parts['dirname']);
			
			return $path_parts['dirname'] . "/" . $path_parts['filename'] . "_thumb." . $path_parts['extension'];
		}
		else
		{
			return false;
		}
	}
	
}