<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Xml_handler
{
	private $xml;
	
	public function setXML($newXML)
	{
		$this->xml = $this->IGMise($newXML);
	}
	private function IGMise($xmlFragment)
	{
		$o  = '<?xml version="1.0" encoding="utf-8"?>\r\n';
		$o .= "<scenedata>\r\n";
		$o .= $xmlFragment . "\r\n";
		$o .= "</scenedata>";
		
		return $o;
	}
	
	public function getTidyXML()
	{
		// Tidy.. the sensible PHP extension way
		/*
		$tidyConfig = array(
           'indent'		=> true,
		   'indent-spaces' => 4,
           'output-xml'	=> true,
		   'input-xml'	=> true,
		   'char-encoding' => 'utf8',
		   'input-encoding' => 'utf8',
		   'wrap' => 999
           );
		
		return tidy_repair_string($this->xml, $tidyConfig, 'utf8');
		*/
		
		// Tidy... the crazy DreamHost way
		$descriptorspec = array(
		  0 => array("pipe", "r"), // stdin is a pipe that the child will read from
		  1 => array("pipe", "w"), // stdout is a pipe that the child will write to
		  2 => array("pipe", "r") // stderr
		);
		
		$process = proc_open('tidy -m --tidy-mark false --indent true --indent-spaces 4 --wrap 999 --output-xml true --input-xml true --char-encoding utf8 --input-encoding utf8', $descriptorspec, $pipes);
		
		if (is_resource($process)) {
		
		  // $pipes now looks like this:
		  // 0 => writeable handle connected to child stdin
		  // 1 => readable handle connected to child stdout
		  // 2 => stderr pipe
		
		  // writes the bad html to the tidy process that is reading from stdin.
		  fwrite($pipes[0], $this->xml);
		  fclose($pipes[0]);
		
		  // reads the good html from the tidy process that is writing to stdout.
		  $good_xml = stream_get_contents($pipes[1]);
		  fclose($pipes[1]);
		
		  // don't care about the stderr, but you might.
		
		  // It is important that you close any pipes before calling
		  // proc_close in order to avoid a deadlock
		  $return_value = proc_close($process);
		}
		
		// now use $good_html for whatever
		return $good_xml;
	}	
}


class Simple_XML_Parser
{
	var $parser;
	var $error_code;
	var $error_string;
	var $current_line;
	var $current_column;
	var $data = array();
	var $datas = array();
   
	function parse($data)
	{
		$this->parser = xml_parser_create('UTF-8');
		xml_set_object($this->parser, $this);
		xml_parser_set_option($this->parser, XML_OPTION_SKIP_WHITE, 1);
		xml_set_element_handler($this->parser, 'tag_open', 'tag_close');
		xml_set_character_data_handler($this->parser, 'cdata');
		if (!xml_parse($this->parser, $data))
		{
			$this->data = array();
			$this->error_code = xml_get_error_code($this->parser);
			$this->error_string = xml_error_string($this->error_code);
			$this->current_line = xml_get_current_line_number($this->parser);
			$this->current_column = xml_get_current_column_number($this->parser);
		}
		else
		{
			$this->data = $this->data['child'];
		}
		xml_parser_free($this->parser);
	}

	function tag_open($parser, $tag, $attribs)
	{
		$this->data['child'][$tag][] = array('data' => '', 'attribs' => $attribs, 'child' => array());
		$this->datas[] =& $this->data;
		$this->data =& $this->data['child'][$tag][count($this->data['child'][$tag])-1];
	}

	function cdata($parser, $cdata)
	{
		$this->data['data'] .= $cdata;
	}

	function tag_close($parser, $tag)
	{
		$this->data =& $this->datas[count($this->datas)-1];
		array_pop($this->datas);
	}
}
?>