<?php

class Medium_data extends Model
{
	
	var $TABLE_NAME = 'medium';
	
	function Medium_data()
	{
		parent::Model();
		
	}
	
	public function getIdFromName($MediumName)
	{
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->where('matname', $MediumName)
				 ->limit(1);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			$row = $query->row();
			return $row->ID;
		}
		else
		{
			return false;
		}
	}
	
	public function getNumberOfMediumsInCategory($categoryID)
	{
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->where('matcategory', $categoryID);
		$query = $this->db->get();
		return $query->num_rows();
	}
	
	public function nameExists($MediumName)
	{
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->where('matname', $MediumName)
				 ->limit(1);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public function addMedium($name, $description, $category, $owner, $thumb, $type, $data)
	{
		$newMedium = array('matname'=>$name,
							 'description'=>$description,
							 'matcategory'=>$category,
							 'owner'=>$owner,
							 'dateadded'=>time(),
							 'thumbnailpath'=>$thumb,
							 'type'=>$type,
							 'data'=>$data,
							 'downloads'=>0);
		if ($this->db->insert($this->TABLE_NAME, $newMedium))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public function modifyMedium($MediumID, $name, $description, $category, $thumb, $data)
	{
		$newMedium = array('matname'=>$name,
							 'description'=>$description,
							 'matcategory'=>$category,
							 'thumbnailpath'=>$thumb,
							 'data'=>$data);
		if ($this->db->where("ID", $MediumID)
					 ->update($this->TABLE_NAME, $newMedium))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public function modifyMediumData($MediumID, $data)
	{
		$newMedium = array('data'=>$data);
		if ($this->db->where("ID", $MediumID)
					 ->update($this->TABLE_NAME, $newMedium))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public function incrementDownloads($MediumID)
	{
		$q = "UPDATE ".$this->TABLE_NAME." SET downloads = (downloads+1) WHERE ID = '$MediumID'";
		return $this->db->query($q);
	}
	
	public function getMediumsInCategory($catID)
	{
		$this->db->select('*, '.$this->TABLE_NAME.'.ID as matID, user.ID as userID')
				 ->from($this->TABLE_NAME)
				 ->where('matcategory', $catID)
				 ->join('user', 'user.ID = '.$this->TABLE_NAME.'.owner')
				 ->orderby('matname', 'asc');
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			$theMats = array();
			foreach($query->result_array() as $row)
			{
				$theMats[$row['matID']] = $row;
			}
			return $theMats;
		}
		else
		{
			return array();
		}
	}
	
	public function getMediumsByOwner($ownerName, $category = NULL)
	{
		$this->db->select('*, '.$this->TABLE_NAME.'.ID as matID, user.ID as userID')
				 ->from($this->TABLE_NAME)
				 ->join('user', 'user.ID = '.$this->TABLE_NAME.'.owner')
				 ->where('username', $ownerName)
				 ->orderby('matname', 'asc');
				 
		if ($category == NULL) $this->db->where('matcategory >', 0);
		if ($category != NULL) $this->db->where('matcategory',$category);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			$theMats = array();
			foreach($query->result_array() as $row)
			{
				$theMats[$row['matID']] = $row;
			}
			return $theMats;
		}
		else
		{
			return array();
		}
	}
	
	public function getMedia()
	{
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->where('type', "medium")
				 ->orderby("matname","asc");
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			$theMedia = array();
			foreach($query->result() as $row)
			{
				$theMedia[$row->ID] = $row->matname;
			}
			return $theMedia;
		}
		else
		{
			return array();
		}
	}
	
	public function retrieveMediumDataById($mediumID)
	{
		/* used for Media, mostly */
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->where('ID', $mediumID);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			foreach($query->result() as $row)
			{
				$theData = $row->data;
			}
			return $theData;
		}
		else
		{
			return array();
		}
	}
	
	public function retrieveMediumDataByName($MediumName)
	{
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->where('matname', $MediumName);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			foreach($query->result() as $row)
			{
				$theData = $row->data;
			}
			return $theData;
		}
		else
		{
			return array();
		}
	}
	
	public function retrieveMedium($MediumID)
	{
		$this->db->select('*, '.$this->TABLE_NAME.'.ID as matID, user.ID as userID, matcategory.ID as matCatID')
				 ->from($this->TABLE_NAME)
				 ->join('user', 'user.ID = '.$this->TABLE_NAME.'.owner')
				 ->join('matcategory','matcategory.ID = '.$this->TABLE_NAME.'.matcategory')
				 ->where($this->TABLE_NAME.'.ID', $MediumID);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			foreach($query->result_array() as $row)
			{
				//$row = $query->result_array();
				$theData = $row;
			}
			return $theData;
		}
		else
		{
			return array();
		}
	}
	
	public function randomMedium($limit = 1)
	{
		$this->db->select('*, '.$this->TABLE_NAME.'.ID as matID, user.ID as userID, matcategory.ID as matCatID')
				 ->from($this->TABLE_NAME)
				 ->join('user', 'user.ID = '.$this->TABLE_NAME.'.owner')
				 ->join('matcategory','matcategory.ID = '.$this->TABLE_NAME.'.matcategory')
				 ->orderby('RAND()')
				 ->where('matcategory >', '0')
				 ->limit($limit);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			foreach($query->result_array() as $row)
			{
				//$row = $query->result_array();
				if ($limit == 1)
				{
					$theData = $row;
				}
				else
				{
					$theData[$row['matID']] = $row;
				}
			}
			return $theData;
		}
		else
		{
			return array();
		}
	}
	
	public function mostDownloaded($limit = 1)
	{
		$this->db->select('*, '.$this->TABLE_NAME.'.ID as matID, user.ID as userID, matcategory.ID as matCatID')
				 ->from($this->TABLE_NAME)
				 ->join('user', 'user.ID = '.$this->TABLE_NAME.'.owner')
				 ->join('matcategory','matcategory.ID = '.$this->TABLE_NAME.'.matcategory')
				 ->orderby('downloads', 'desc')
				 ->where('matcategory >', '0')
				 ->limit($limit);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			foreach($query->result_array() as $row)
			{
				//$row = $query->result_array();
				if ($limit == 1)
				{
					$theData = $row;
				}
				else
				{
					$theData[$row['matID']] = $row;
				}
			}
			return $theData;
		}
		else
		{
			return array();
		}
	}
	
	public function newestMedium()
	{
		$this->db->select('*, '.$this->TABLE_NAME.'.ID as matID, user.ID as userID, matcategory.ID as matCatID')
				 ->from($this->TABLE_NAME)
				 ->join('user', 'user.ID = '.$this->TABLE_NAME.'.owner')
				 ->join('matcategory','matcategory.ID = '.$this->TABLE_NAME.'.matcategory')
				 ->where('matcategory >', '0')
				 ->orderby('dateadded','desc')
				 ->limit(1);
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			foreach($query->result_array() as $row)
			{
				//$row = $query->result_array();
				$theData = $row;
			}
			return $theData;
		}
		else
		{
			return array();
		}
	}
	
	public function findMediums($string)
	{
		/* WARNING - this doesn't return Media, or unfinished Uploads !! */
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->like('matname', $string)
				 ->where('matcategory >', '0');
		$query = $this->db->get();
		if ($query->num_rows()>0)
		{
			$names = array();
			foreach($query->result() as $row)
			{
				$names[] = $row->matname;
			}
			return $names;
		}
		else
		{
			return array();
		}
	}
	
	public function getNumberOfUncategorisedMediums()
	{
		$this->db->select('*')
				 ->from($this->TABLE_NAME)
				 ->where('matcategory', '-1')
				 ->where('owner', $this->session->userdata("userid"));
		$query = $this->db->get();
		return $query->num_rows();
	}
	
	public function deleteMedium($MediumID)
	{
		if ($this->db->where("ID",$MediumID)
				     ->delete($this->TABLE_NAME))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

?>