<?php

class Category_data extends Model
{	

	var $catLevel = -1;

	function Category_data()
	{
		parent::Model();
		
	}
	
	/* returns a tree of nested categories, starting with those that have parent = $root */
	public function getCategories($which, $root = 0)
	{	
		$this->catLevel++;
		
		$this->db->select("*")
				 ->from($which."category")
				 ->where("parent",$root)
				 ->where("ID >", '0')
				 ->orderby("catname","asc");
				 
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			$catList = array();
			foreach($query->result() as $row)
			{
				$catList[$row->ID] = str_repeat("-",$this->catLevel) . $row->catname;
				$catList += $this->getCategories($which, $row->ID);
			}
			$this->catLevel--;
			return $catList;
		}
		else
		{
			$this->catLevel--;
			return array();
		}
	}
	
	public function getCategoryNameFromId($which, $catID)
	{
		$this->db->select("*")
				 ->from($which."category")
				 ->where("ID",$catID);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			$row = $query->row();
			return $row->catname;
		}
		else
		{
			return false;
		}
	}
	
	public function createNewCategory($type, $name, $parent)
	{
		/*
			[type]category
			ID				auto_increment
			catname			varchar
			parent			int
		 */
		$newCat = array('catname'=>$name,
						'parent'=>$parent);
		if ($this->db->insert($type.'category', $newCat))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}

?>