<?php
	$this->load->view("pageParts/header");	
	$this->load->view("pageParts/leftPanel");
?>
	
	<div class="contentsArea" id="cAMiddle">
		
	<?=form_open_multipart("create/diffuse")?>
		
		<h2>Create new Diffuse Material</h2>
		
		<? $this->load->view("create/textureUploadNotice") ?>
		
		<div>
			<div class="left">
				<p>
					Material name:<br />
					<input name="DN" value="<?=$this->validation->DN?>" />
				</p>	
			</div>
			<div class="left leftMargin">
				<? $this->load->view("create/categoryChooser"); ?>
			</div>
		</div>
			
		<p class="clear">
			Description:<br />
			<textarea class="XMLDisplay" name="Description"><?=$this->validation->Description?></textarea>
		</p>
		
		<p>
			Preview (jpg or png, will be resized to 150x150, max upload 2MB 256x256):<br />
			<input type="file" name="thumbnail" />
		</p>
		
		<p><label>Transmitter: <input class="check" type="checkbox" name="DT_enabled" id="DT_enabled" <?= $this->validation->set_checkbox('DT_enabled', 'on')?> /></label></p>
		
		<p>Albedo Spectrum:</p>
		<? $this->load->view("utils/spectrumChooser", array("prefix"=>"ASTabs",
															"val_R"=> $this->validation->ASTabs_RGB_R,
															"val_G"=> $this->validation->ASTabs_RGB_G,
															"val_B"=> $this->validation->ASTabs_RGB_B,
															"val_Gamma"=> $this->validation->ASTabs_RGB_Gamma,
															"val_PMin"=> $this->validation->ASTabs_PMin,
															"val_PWidth"=> $this->validation->ASTabs_PWidth,
															"val_PPeak"=> $this->validation->ASTabs_PPeak,
															"val_PBase"=> $this->validation->ASTabs_PBase,
															"val_BBTemp"=> $this->validation->ASTabs_BBTemp,
															"val_BBGain"=> $this->validation->ASTabs_BBGain,
															"val_Uniform"=> $this->validation->ASTabs_Uniform,
															"val_TAB_START"=> $this->validation->ASTabs_TAB_START,
															"val_TAB_END"=> $this->validation->ASTabs_TAB_END,
															"val_TAB_VALUES"=> $this->validation->ASTabs_TAB_VALUES,
															)); ?>
		
		<p><label>Albedo Texture: <input class="check" type="checkbox" name="AT_enabled" id="AT_enabled" <?= $this->validation->set_checkbox('AT_enabled', 'on')?> /></label></p>
		<? $this->load->view("utils/textureChooser", array("prefix"=>"ATTabs",
														   "val_UVSet"=> $this->validation->ATTabs_UVSet,
														   "val_Path"=> $this->validation->ATTabs_Path,
														   "val_Exponent"=> $this->validation->ATTabs_Exponent,
														   "val_A"=> $this->validation->ATTabs_A,
														   "val_B"=> $this->validation->ATTabs_B,
														   "val_C"=> $this->validation->ATTabs_C,
														   )); ?>
		
		<p><label>Bump Map: <input class="check" type="checkbox" name="BM_enabled" id="BM_enabled" <?= $this->validation->set_checkbox('BM_enabled', 'on')?> /></label></p>
		<? $this->load->view("utils/textureChooser", array("prefix"=>"BMTabs",
														   "val_UVSet"=> $this->validation->BMTabs_UVSet,
														   "val_Path"=> $this->validation->BMTabs_Path,
														   "val_Exponent"=> $this->validation->BMTabs_Exponent,
														   "val_A"=> $this->validation->BMTabs_A,
														   "val_B"=> $this->validation->BMTabs_B,
														   "val_C"=> $this->validation->BMTabs_C,
														   )); ?>
		
		<p><?=$this->validation->error_string?></p>
		<p><input type="submit" value="Create" /></p>
	
	</form>
	</div>
	
	<script type="text/javascript">
		$(document).ready(function(){

			var ASTabs_Active = 1;
			$('#ASTabs ul').tabs({ fxFade: true, fxSpeed: 'fast',
				show: function() {
					ASTabs_Active = $('#ASTabs ul').tabsSelected();
					$('input#ASTabs_activeTab').val(ASTabs_Active);
				}
			});
			
			$('#ATTabs ul').tabs({ fxFade: true, fxSpeed: 'fast' });
			$('#BMTabs ul').tabs({ fxFade: true, fxSpeed: 'fast' });
			
			if ($('#AT_enabled').attr("checked") == true)
			{
				$('#ATTabs').show();
				$('#ASTabs').hide();
			}
			
			$('#AT_enabled').click(function(){
				$('#ATTabs').slideToggle();
				$('#ASTabs').slideToggle();
			});
			
			if ($('#BM_enabled').attr("checked") == true)
			{
				$('#BMTabs').show()
			}
			
			$('#BM_enabled').click(function(){
				$('#BMTabs').slideToggle();
			});
		});
	</script>
	
<?php
	$this->load->view("pageParts/rightPanel");
	$this->load->view("pageParts/footer");
?>