<?php
	$this->load->view("pageParts/header");	
	$this->load->view("pageParts/leftPanel");
?>
	
	<div class="contentsArea" id="cAMiddle">
		
	<?=form_open_multipart("create/phong")?>
	
		<h2>Create new Phong Material</h2>
		
		<? $this->load->view("create/textureUploadNotice") ?>
		
		<div>
			<div class="left">
				<p>
					Material name:<br />
					<input name="DN" value="<?=$this->validation->DN?>" />
				</p>	
			</div>
			<div class="left leftMargin">
				<? $this->load->view("create/categoryChooser"); ?>
			</div>
		</div>
			
		<p class="clear">
			Description:<br />
			<textarea class="XMLDisplay" name="Description"><?=$this->validation->Description?></textarea>
		</p>
		
		<p>
			Preview (jpg or png, will be resized to 150x150, max upload 2MB 256x256):<br />
			<input type="file" name="thumbnail" />
		</p>
		
		<div>
			<div class="left">
				<p>
					IOR:<br />
					<input class="inputDouble" name="IOR" id="IOR" value="<?=$this->validation->IOR?>" />
				</p>
			</div>
			<div class="left leftMargin">
				<p>
					Exponent:<br />
					<input class="inputDouble" name="Exponent" value="<?=$this->validation->Exponent?>" />
				</p>
			</div>
		</div>
		
		<p class="clear">
			<label>NK data (complex IOR): <input class="check" type="checkbox" name="NK_enabled" id="NK_enabled" <?= $this->validation->set_checkbox('NK_enabled', 'on')?> /></label>
		</p>
		
		<div id="NKOpt" style="display:none;">
			<p>NK Path: <input name="NK_data" value="<?=$this->validation->NK_data?>" /></p>
		</div>
		
		<p>Diffuse Albedo Spectrum:</p>
		<? $this->load->view("utils/spectrumChooser", array("prefix"=>"ASTabs",
															"val_R"=> $this->validation->ASTabs_RGB_R,
															"val_G"=> $this->validation->ASTabs_RGB_G,
															"val_B"=> $this->validation->ASTabs_RGB_B,
															"val_Gamma"=> $this->validation->ASTabs_RGB_Gamma,
															"val_PMin"=> $this->validation->ASTabs_PMin,
															"val_PWidth"=> $this->validation->ASTabs_PWidth,
															"val_PPeak"=> $this->validation->ASTabs_PPeak,
															"val_PBase"=> $this->validation->ASTabs_PBase,
															"val_BBTemp"=> $this->validation->ASTabs_BBTemp,
															"val_BBGain"=> $this->validation->ASTabs_BBGain,
															"val_Uniform"=> $this->validation->ASTabs_Uniform,
															"val_TAB_START"=> $this->validation->ASTabs_TAB_START,
															"val_TAB_END"=> $this->validation->ASTabs_TAB_END,
															"val_TAB_VALUES"=> $this->validation->ASTabs_TAB_VALUES,
															)); ?>
		
		<p><label>Albedo Texture: <input class="check" type="checkbox" name="AT_enabled" id="AT_enabled" <?= $this->validation->set_checkbox('AT_enabled', 'on') ?> /></label></p>
		<? $this->load->view("utils/textureChooser", array("prefix"=>"ATTabs",
														   "val_UVSet"=> $this->validation->ATTabs_UVSet,
														   "val_Path"=> $this->validation->ATTabs_Path,
														   "val_Exponent"=> $this->validation->ATTabs_Exponent,
														   "val_A"=> $this->validation->ATTabs_A,
														   "val_B"=> $this->validation->ATTabs_B,
														   "val_C"=> $this->validation->ATTabs_C,
														   )); ?>
															   
		<p><label>Bump Map: <input class="check" type="checkbox" name="BM_enabled" id="BM_enabled" <?= $this->validation->set_checkbox('BM_enabled', 'on')?> /></label></p>
		<? $this->load->view("utils/textureChooser", array("prefix"=>"BMTabs",
														   "val_UVSet"=> $this->validation->BMTabs_UVSet,
														   "val_Path"=> $this->validation->BMTabs_Path,
														   "val_Exponent"=> $this->validation->BMTabs_Exponent,
														   "val_A"=> $this->validation->BMTabs_A,
														   "val_B"=> $this->validation->BMTabs_B,
														   "val_C"=> $this->validation->BMTabs_C,
														   )); ?>
														   
		<p><label>Exponent Map: <input class="check" type="checkbox" name="EM_enabled" id="EM_enabled" <?= $this->validation->set_checkbox('EM_enabled', 'on')?> /></label></p>
		<? $this->load->view("utils/textureChooser", array("prefix"=>"EMTabs",
														   "val_UVSet"=> $this->validation->EMTabs_UVSet,
														   "val_Path"=> $this->validation->EMTabs_Path,
														   "val_Exponent"=> $this->validation->EMTabs_Exponent,
														   "val_A"=> $this->validation->EMTabs_A,
														   "val_B"=> $this->validation->EMTabs_B,
														   "val_C"=> $this->validation->EMTabs_C,
														   )); ?>
		
		<p><?=$this->validation->error_string?></p>
		<p><input type="submit" value="Create" /></p>
	
	</form>
	</div>
	
	<script type="text/javascript">
		$(document).ready(function(){

			var ASTabs_Active = 1;
			$('#ASTabs ul').tabs({ fxFade: true, fxSpeed: 'fast',
				show: function() {
					ASTabs_Active = $('#ASTabs ul').tabsSelected();
					$('input#ASTabs_activeTab').val(ASTabs_Active);
				}
			});
			
			$('#ATTabs ul').tabs({ fxFade: true, fxSpeed: 'fast' });
			$('#BMTabs ul').tabs({ fxFade: true, fxSpeed: 'fast' });
			$('#EMTabs ul').tabs({ fxFade: true, fxSpeed: 'fast' });
			
			var nkState = ($('#NK_enabled').attr("checked") == true);
			if (nkState)
			{
				$('#NKOpt').show();
				$('#IOR').attr("disabled","true");
			}
			
			$('#NK_enabled').click(function(){
				$('#NKOpt').slideToggle();
				if (nkState==1)
				{
					nkState = 0;
					$('#IOR').removeAttr("disabled");
				}
				else
				{
					nkState = 1;
					$('#IOR').attr("disabled","true");
				}
			});
			
			if ($('#AT_enabled').attr("checked") == true)
			{
				$('#ATTabs').show();
				$('#ASTabs').hide();
			}
			
			$('#AT_enabled').click(function(){
				$('#ATTabs').slideToggle();
				$('#ASTabs').slideToggle();
			});
			
			if ($('#BM_enabled').attr("checked") == true)
			{
				$('#BMTabs').show()
			}
			
			$('#BM_enabled').click(function(){
				$('#BMTabs').slideToggle();
			});
			
			if ($('#EM_enabled').attr("checked") == true)
			{
				$('#EMTabs').show();
			}
			
			$('#EM_enabled').click(function(){
				$('#EMTabs').slideToggle();
			});
		});
	</script>
	
<?php
	$this->load->view("pageParts/rightPanel");
	$this->load->view("pageParts/footer");
?>